<template>
  <v-container>
    <v-dialog v-model="dialog" max-width="75vw" persistent>
      <v-card>
        <v-card-title v-if="processType === 'add' || processType === 'add-restricted'">
          <v-layout>
            <span>
              <v-icon v-if="processType === 'add-restricted'">mdi-shield-lock-outline</v-icon>
              Create {{ processType === 'add-restricted' ? 'Admin-' : ''}}Contact for
            </span>
          </v-layout>
        </v-card-title>
        <v-card-title v-if="processType !== 'add' && processType !== 'add-restricted'">
          <v-layout v-if="getRoleRestrictions(props.item).length > 0">
              <v-icon class="mr-2">mdi-shield-lock-outline</v-icon>
              {{ processType === 'edit-restricted' ? 'Edit Admin-Contact:' : 'View Admin-Contact:'}}
              {{ getTitle(props.item)}}
          </v-layout>
          <v-layout v-else>
              {{ processType === 'edit' ? 'Edit Contact: ' : 'View Contact: ' }}
              {{ getTitle(props.item)}}
          </v-layout>
          <v-chip v-if="props.item.is_expired" class="warning align-content-center">
            <v-icon v-if="item['is_expired']" small class="mr-1 theme--dark">mdi-clock-alert</v-icon>
            Expired
          </v-chip>
        </v-card-title>
        <v-container class="row py-0">
          <div class="col col-6">
            <div v-if="$store.getters['user/isOrgaAdmin']">
              <v-select
                v-if="organisations && organisations.length > 1"
                v-model="initialOrga"
                :items="organisations"
                dense
                :loading="isOrgLoading"
                return-object
                item-text="name"
                single-line
                :disabled="processType === 'view' || (processType === 'edit' && props.item.is_rule_destination)"
                @change="editFormChanged()"
              >
              </v-select>
            </div>
            <span v-else class="ml-2">
              {{ $store.state.user.selectedNode.name }}
            </span>
            <v-autocomplete
              v-if="!$store.getters['user/isOrgaAdmin']"
              v-model="initialOrga"
              :search-input.sync="search"
              :items="organisations"
              dense
              :loading="isOrgLoading"
              return-object
              prepend-icon="mdi-database-search"
              label="Search for organisation"
              item-text="name"
              single-line
              clearable
              persistent-hint
              hint="Selecting organisation is required"
              :rules="[v => !!v || 'Please select organisation']"
              ref="orgaField"
              :disabled="processType === 'view' || (processType === 'edit' && props.item.is_rule_destination)"
              @change="editFormChanged()"
              @click:clear="clearOrganisation();"
            >
            </v-autocomplete>
          </div>
          <div class="col col-6">
            <div v-if="processType === 'edit' && props.item.is_rule_destination">
              <v-icon
                  v-if="!showOrganisationNotEditableInfo"
                  color="grey"
                  @click="showOrganisationNotEditableInfo = true"
                  class="mt-6"
              >
                mdi-lock-alert-outline
              </v-icon>
              <v-alert
                  v-model="showOrganisationNotEditableInfo"
                  dismissible
                  dense
                  type="info"
                  colored-border
                  border="left"
                  elevation="2"
                  transition="scale-transition"
              >
                The organization cannot be changed since the contact is assigned to one or more Netobject-Rules.
              </v-alert>
            </div>
          </div>
        </v-container>
        <v-container class="row mb-1">
          <div class="col col-6">
            <v-select
              :items="roles"
              label="Roles"
              item-text="name"
              v-model="selectedRoles"
              dense
              :rules="[v => !!(v && v.length) || 'Role is required']"
              prepend-inner-icon="mdi-account-star"
              required
              hint="Selecting role(s) is required"
              persistent-hint
              multiple
              small-chips
              clearable
              @change="initializeFields(); editFormChanged()"
              return-object
              :disabled="processType === 'view' || processType === 'view-restricted'"
            >
              <template v-slot:selection="{ item }">
                <v-tooltip color="black" bottom>
                  <template #activator="{ on }">
                    <v-chip
                      v-on="on"
                      small
                      close
                      @click:close="removeItemFromSelectedRole(item.name); editFormChanged();"
                      v-on:click.ctrl.stop="copyToClipboard($store.getters['application/getRoleDescription'](item.name))"
                    >
                      {{ item.name }}
                    </v-chip>
                  </template>
                  <span style="white-space: pre;">
                    {{ $store.getters['application/getRoleDescription'](item.name)}}<br>
                    <small class="align-center">&nbsp;(Use Strg + Click to copy)</small>
                  </span>
                </v-tooltip>
              </template>
              <template v-slot:item="{item}">
                <v-tooltip color="black" bottom>
                  <template #activator="{ on }">
                    <v-list-item v-on="on">
                      <v-list-item-action>
                        <v-icon
                            v-if="selectedRoles !== null && selectedRoles.includes(item)"
                            color="primary"
                            class="mr-3">
                          mdi-checkbox-marked
                        </v-icon>
                        <v-icon v-else class="mr-3">
                          mdi-checkbox-blank-outline
                        </v-icon>
                      </v-list-item-action>
                      <v-list-item-content>
                        <v-list-item-title v-on:click.ctrl.stop="copyToClipboard($store.getters['application/getRoleDescription'](item.name))">
                          {{ item.name }}
                        </v-list-item-title>
                      </v-list-item-content>
                    </v-list-item>
                  </template>
                  <span style="white-space: pre;">
                    {{ $store.getters['application/getRoleDescription'](item.name)}}<br>
                    <small class="align-center">&nbsp;(Use Strg + Click to copy)</small>
                  </span>
                </v-tooltip>
              </template>
            </v-select>
          </div>
          <div class="col col-6">
            <v-select
              v-if="!$store.getters['user/isOrgaAdmin']"
              :items="tags"
              item-text="name"
              v-model="selectedTags"
              @change="editFormChanged()"
              dense
              label="Tags"
              prepend-inner-icon="mdi-tag"
              required
              multiple
              clearable
              persistent-hint
              small-chips
              return-object
              deletable-chips
              :disabled="processType === 'view' || processType === 'view-restricted'"
            ></v-select>
          </div>
        </v-container>
        <div class="d-flex align-center justify-start">
        </div>
        <v-divider></v-divider>
        <v-card-text>
          <v-container px-0>
            <v-form v-model="valid" ref="form" class="row">
              <v-text-field
                v-if="loading"
                loading
                disabled
                dense
                class="col col-12"
              ></v-text-field>
              <v-col
                v-for="(field, index) in contactFields"
                cols="6"
                :key="index"
              >
                <DynamicEmailField v-if="['email'].indexOf(field.type) !== -1"
                 :fieldName="field.name"
                 :label="field.label"
                 :hint="field.hint"
                 :email="contactValues[field.name]"
                 :mailDomains="(initialOrga?.mail_domains ?? usedOrga?.mail_domains) ?? {}"
                 :disabled="processType === 'view' || processType === 'view-restricted'"
                 :required="field.required"
                 @dynamic-email-object="checkDynamicEmailField"
                 @hook:mounted="triggerFormValidation();"
                 @hook:updated="triggerFormValidation();"
                />
                <v-text-field
                  v-if="
                    ['text', 'phone', 'integer'].indexOf(
                      field.type
                    ) !== -1 &&
                      // Use another element for dropdown elements
                      !field.dropdown
                  "
                  v-model="contactValues[field.name]"
                  v-on:input="editFormChanged()"
                  :disabled="processType === 'view' || processType === 'view-restricted'"
                  :label="field.label"
                  :hint="field.hint"
                  :prepend-inner-icon="
                    field.type === 'phone'
                      ? getFieldIcon(field.type)
                      : getFieldIcon(field.name)
                  "
                  :rules="getFieldRule(field)"
                  persistent-hint
                  :prefix="['phone'].indexOf(field.type) !== -1 ? '+' : ''"
                  :type="
                    ['phone', 'phone_1', 'phone_2', 'integer'].indexOf(
                      field.type
                    ) !== -1
                      ? 'number'
                      : 'string'
                  "
                >
                </v-text-field>
                <v-file-input
                  v-if="
                    [
                      'pdf',
                      'aec_code_of_conduct',
                      'atc_Code_of_conduct',
                      'document'
                    ].indexOf(field.type) !== -1
                  "
                  :label="field.label"
                  v-model="contactValues[field.name]"
                  @change="editFormChanged()"
                  :disabled="processType === 'view' || processType === 'view-restricted'"
                  dense
                  small-chips
                  :rules="getFieldRule(field)"
                  @click:clear="
                    toDeletePdf = {
                      id: contactValues[field.name].id,
                      name: contactValues[field.name].name
                    }
                  "
                  accept="application/pdf"
                >
                </v-file-input>
                <v-file-input
                  v-if="['openpgp_pubkey'].indexOf(field.type) !== -1"
                  :label="field.label"
                  v-model="contactValues[field.name]"
                  dense
                  :error="!isOpenpgpKeyValid"
                  :error-messages="
                    !isOpenpgpKeyValid ? openpgpErrorMessage : ''
                  "
                  @change="checkUploadedFile(field); editFormChanged()"
                  :disabled="processType === 'view' || processType === 'view-restricted'"
                  @click:clear="
                    isOpenpgpKeyValid = true;
                    fileContent[field.name] = '';
                  "
                  small-chips
                >
                </v-file-input>
                <v-file-input
                  v-if="['s_mime_cert'].indexOf(field.type) !== -1"
                  :label="field.label"
                  v-model="contactValues[field.name]"
                  dense
                  @change="checkUploadedFile(field); editFormChanged()"
                  :disabled="processType === 'view' || processType === 'view-restricted'"
                  :error="!isSmimeKeyValid"
                  :error-messages="!isSmimeKeyValid ? smimeErrorMessage : ''"
                  @click:clear="
                    isSmimeKeyValid = true;
                    fileContent[field.name] = '';
                  "
                  small-chips
                >
                </v-file-input>
                <v-textarea
                  v-if="field.type === 'text_area'"
                  name="input-7-1"
                  :label="field.label"
                  :hint="field.hint"
                  outlined
                  persistent-hint
                  v-model="contactValues[field.name]"
                  v-on:input="editFormChanged()"
                  :disabled="processType === 'view' || processType === 'view-restricted'"
                ></v-textarea>
                <v-select
                  v-if="Object.keys(field).includes('dropdown')"
                  :label="field.label"
                  :hint="field.hint"
                  :items="field.dropdown"
                  item-text="label"
                  item-value="value"
                  persistent-hint
                  v-model="contactValues[field.name]"
                  @change="editFormChanged()"
                  :disabled="processType === 'view' || processType === 'view-restricted'"
                  dense
                >
                </v-select>
              </v-col>
            </v-form>
          </v-container>
          <UIAlert
            v-if="hasRequestError || hasDeletionError"
            v-bind:isSuccessful="false"
            v-bind:message="$store.state.application.httpErrorMessage"
          />
        </v-card-text>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn
            color="blue darken-1"
            text
            @click="
              $emit('child-object', {
                closeDialog: true,
                contactChanged: false
              }); updateAvailableTenantContactRoles();
            "
          >
            {{ processType !== 'view' || processType !== 'view-restricted' ? 'Cancel' : 'Close' }}
          </v-btn>
          <v-btn
            v-if="processType === 'add' || processType === 'add-restricted'"
            color="blue darken-1"
            text
            :disabled="
              // Deactivate button when:
              // Form is not valid
              !valid ||
                // Public key is not valid
                !isOpenpgpKeyValid ||
                !isSmimeKeyValid ||
                // There is/are no selected role(s)
                (selectedRoles && !selectedRoles.length) ||
                // There is no selected organisation
                ($store.getters['user/isOrgaAdmin']
                  ? Object.keys(initialOrga).length === 0
                  : Object.keys(usedOrga).length === 0)
            "
            @click="addContact()"
          >
            Create
          </v-btn>
          <v-btn
              v-if="(processType === 'edit' || processType === 'edit-restricted') && hasEditFormChanged"
            color="blue darken-1"
            text
            :disabled="!valid"
            @click="updateContact()"
            >Update</v-btn
          >
          <v-btn
              v-if="(processType === 'edit' || processType === 'edit-restricted') && !hasEditFormChanged"
              color="blue darken-1"
              text
              :disabled="!valid"
              @click="confirmWithoutChange()"
          >Confirm without change</v-btn
          >
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-container>
</template>
<style lang="scss" scoped>
// Hide spin button for text-fields of type number
// as these buttons are not necessary here.
::v-deep input::-webkit-outer-spin-button,
::v-deep input::-webkit-inner-spin-button {
  -webkit-appearance: none;
  margin: 0;
}
</style>
<script setup lang="ts">
/*
 * This file is Free Software under GNU Affero General Public License v >= 3.0
 * without warranty, see README.md and license for details.
 *
 * SPDX-License-Identifier: AGPL-3.0-or-later
 *
 * SPDX-FileCopyrightText: 2020 nic.at GmbH <https://nic.at>
 * Software-Engineering: 2020 Intevation GmbH <https://intevation.de>
 *
 * Author(s):
 * 2021, 2022 Fadi Abbud <fadi.abbud@intevation.de>
 */
import { useForm } from "@/lib/use-form";
import { useOrganisation } from "@/lib/use-organisation";
import {
  getContactFields,
  getFieldIcon,
  getFieldRule, getRoleRestrictions,
  getUsedRoles,
  getTitle
} from "@/lib/use-fieldbuilder";
import { useStore } from "@/store";
import {
  computed,
  defineAsyncComponent,
  nextTick,
  onMounted,
  ref,
  watch
} from "vue";
import { HTTP } from "../../lib/http";
import debounce from "debounce";
const UIAlert = defineAsyncComponent(() =>
  import("@/components/ui/UIAlert.vue")
);
const DynamicEmailField = defineAsyncComponent(() =>
  import("@/components/ui/DynamicEmailField.vue")
);
const props = defineProps({
  processType: String,
  item: Object
});
const emit = defineEmits(["child-object"]);

const store = useStore();
const roles = ref([]);

const updateAvailableTenantContactRoles = (organisationTenants = null) => {
  let tenants = [];

  if (organisationTenants) {
    if (Array.isArray(organisationTenants)) {
      tenants = organisationTenants;
    } else {
      tenants = Object.keys(organisationTenants);
    }
  }

  roles.value = store.getters["application/getRolesByTenants"](tenants);
}

const updateAvailableAdminRoles = () => {
  roles.value = store.getters["application/getPortalAdminRoles"];
}

// Form
const hasRequestError = ref(false);
const hasEditFormChanged = ref(false);
const showOrganisationNotEditableInfo = ref(false);
const { form, valid, loading } = useForm();

const editFormChanged = (hasChanged = true) => {
  hasEditFormChanged.value = hasChanged;
};

const selectedRoles = ref();
selectedRoles.value = [];
const contactFields = ref();
// Variable to store the fields' values
const contactValues = ref({});
// Build the contact fields according to the selected roles
const initializeFields = () => {
  contactFields.value = [];
  if (selectedRoles.value && selectedRoles.value.length) {
    contactFields.value = getContactFields(selectedRoles.value);
    nextTick(() => {
      form.value.validate();
    });
  }
};
const dialog = ref(true);
const { organisations, isOrgLoading, getOrganisations } = useOrganisation();
const isOrgaUpdating = ref(false);
const usedOrga = ref({});
const initialOrga = computed({
  get: () => {
    // Select the current organisation for orga admin by default
    if (store.getters["user/isOrgaAdmin"]) {
      return organisations.value
        ? organisations.value.filter(
            o => o.organisation_id === store.state.user.selectedNode.node_id
          )[0]
        : {};
    } else if ((props.processType === 'edit' || props.processType === 'view') && !isOrgaUpdating.value) {
      return props.item && organisations.value ?
          organisations.value.filter(o => o.organisation_id === props.item.organisation_id)[0] :
          {};
    }
    return {};
  },
  set: val => {
    usedOrga.value = val;
  }
});
const orgaField = ref();
const selectedTags = ref();
// Get Tags
const tags = computed(() => {
  return store.state.contact.contactTags;
});
const setRequestPayload = () => {
  const formdata = new FormData();
  // Exclude public key matertials as they should be treated differently
  for (const f of contactFields.value.filter(
    f => ["openpgp_pubkey", "s_mime_cert"].indexOf(f.type) === -1
  )) {
    if (f.type === "integer") {
      formdata.append(f.name, contactValues.value[f.name] || -1);
      continue;
    }
    // Include file in request only if the field contains a real file
    // as long as by updating the name of file is displayed, and
    // uploading a new one will replace the before saved one.
    if (f.type === "pdf" && !(contactValues.value[f.name] instanceof File)) {
      // Ignore file field
      continue;
    }
    // Set empty string for the case of clearing a field value
    formdata.append(f.name, contactValues.value[f.name] || "");
  }
  // set the files content
  Object.keys(fileContent.value).forEach(f => {
    // Do not set formdata if there is no content
    formdata.append(f, fileContent.value[f] || " ");
  });
  if (selectedTags.value && selectedTags.value.length) {
    selectedTags.value.forEach((t, i) => {
      formdata.append(`tags[${i}]`, t.contact_tag_id);
    });
  }
  if (selectedRoles.value && selectedRoles.value.length) {
    selectedRoles.value.forEach((t, i) => {
      formdata.append(`roles[${i}]`, t.name);
    });
  }

  if (props.processType === 'add-restricted') {
    formdata.append("restrict_to_client_roles[0]", "portaladmin");
  }

  if (props.processType === 'edit' || props.processType === 'edit-restricted') {
    formdata.append("organisation_id",
        Object.keys(usedOrga.value).length ?
            usedOrga.value["organisation_id"] :
            initialOrga.value["organisation_id"]
    );
  }

  return formdata;
};
// Add Contact
const addContact = () => {
  loading.value = true;
  HTTP.post(
    `/organisations/${
      Object.keys(usedOrga.value).length
        ? usedOrga.value["organisation_id"]
        : initialOrga.value["organisation_id"]
    }/contacts`,
    setRequestPayload(),
    {
      headers: {
        "Content-Type": "multipart/form-data"
      }
    }
  )
    .then(() => {
      emit("child-object", {
        closeDialog: true,
        contactChanged: true
      });
    })
    .catch(() => {
      hasRequestError.value = true;
    })
    .finally(() => {
      loading.value = false;
    });
};
const pdfs = ref();
pdfs.value = [];
// Update Contact
const setInitialValues = () => {
  if (props.item) {

    contactFields.value.forEach(f => {
      if (f.type === "text" && f.dropdown) {
        contactValues.value[f.name] = props.item
          ? props.item[f.name].value
          : "";
      } else if (["pdf"].indexOf(f.type) !== -1) {
        // necessary for <v-field-input>
        contactValues.value[f.name] =
          props.item && props.item[f.name] ? props.item[f.name] : null;
      } else if (["openpgp_pubkey", "s_mime_cert"].indexOf(f.type) !== -1) {
        const content = props.item ? props.item[f.name] : "";
        if (content) {
          // Set the file-content to be sent to the backend
          // as this field is treated like any "text" field
          fileContent.value[f.name] = content;
          contactValues.value[f.name] = {
            // Use the first 30 character for the file name
            name: `${content.split("\n")[1].substring(0, 30)}`
          };
        }
      } else {
        contactValues.value[f.name] =
          // Avoid "-1" Value for "zip" field
          props.item && props.item[f.name] !== -1 ? props.item[f.name] : "";
      }
    });
    if (props.item.tags) {
      selectedTags.value = props.item.tags;
    }
    if ((props.processType === 'edit' || props.processType === 'view') && props.item.organisation_tenants) {
      updateAvailableTenantContactRoles(props.item.organisation_tenants);
    }
  }
};
const toDeletePdf = ref();
const hasDeletionError = ref(false);
const deletePDf = () => {
  return new Promise<void>((resolve, reject) => {
    loading.value = true;
    hasDeletionError.value = false;
    HTTP.delete("/pdf/" + toDeletePdf.value.id)
      .then(() => {
        resolve();
      })
      .catch(() => {
        hasDeletionError.value = true;
        reject();
      })
      .finally(() => {
        loading.value = false;
      });
  });
};
const sendUpdateRequest = () => {
  if (props.item) {
    const formdata = setRequestPayload();
    // Form Method Spoofing: For Laravel to handle the POST as a PUT action.
    formdata.append("_method", "PUT");
    HTTP.post(
      `/organisations/${props.item.organisation_id}/contacts/
          ${props.item.contact_id}`,
      formdata,
      {
        headers: {
          "Content-Type": "multipart/form-data"
        }
      }
    )
      .then(() => {
        emit("child-object", {
          closeDialog: true,
          contactChanged: true
        });
      })
      .catch(() => {
        hasRequestError.value = true;
      })
      .finally(() => {
        loading.value = false;
      });
  }
};
const updateContact = () => {
  if (props.item) {
    if (toDeletePdf.value && toDeletePdf.value.id) {
      deletePDf().then(() => {
        sendUpdateRequest();
      });
    } else {
      sendUpdateRequest();
    }
  }
};

const confirmWithoutChange = () => {
  sendUpdateRequest();
};

onMounted(() => {
  if (store.getters["user/isOrgaAdmin"]) {
    getOrganisations();
  } else {
    if (props.processType === "edit") {
      getOrganisations(1, 10, null, 'asc', null, props.item.organisation_id);
    } else {
      getOrganisations(1);
    }
    // Load the tags for portal/tenant-admin(s)
    if (!tags.value || !tags.value.length) {
      loading.value = true;
      store
        .dispatch("contact/loadContactTags")
        .then()
        .catch(() => (hasRequestError.value = true))
        .finally(() => {
          loading.value = false;
        });
    }
    if (orgaField.value) {
      orgaField.value.validate();
    }
  }

  // Init contact role set.
  if (props.processType === "edit" || props.processType === "view") {
    updateAvailableTenantContactRoles(props.item.organisation_tenants);
  } else if (props.processType === "edit-restricted" || props.processType === "view-restricted") {
    updateAvailableAdminRoles();
  }

  // Initialize values for view and update views.
  if (props.processType !== "add" && props.processType !== "add-restricted") {
    selectedRoles.value = getUsedRoles(props.item);
    initializeFields();
    setInitialValues();
  }

  form.value.validate();

  if (props.processType === "add") {
    updateAvailableTenantContactRoles();
  }

  if (props.processType === "add-restricted") {
    updateAvailableAdminRoles();
  }
});

const search = ref(null);
const triggerSearch = debounce(searchString => {
  getOrganisations(1, undefined, searchString);
}, 500);

watch(
  // Make a request for each change in the search-field.
  () => search.value,
  (newValue, oldValue) => {
    if (orgaField.value) {
      orgaField.value.validate();
    }

    if (oldValue !== newValue) {
      triggerSearch(newValue);
    }
  }
);

watch(() => initialOrga.value, (organisation) => {
  usedOrga.value = organisation;
});

watch(() => usedOrga.value, (organisation) => {

  // Omit update of role set for admin contacts.
  if (props.processType === 'add-restricted' || props.processType === 'edit-restricted') {
    return;
  }

  const organisationTenants = [];
  if (organisation && organisation?.tenants?.length) {
    organisation.tenants.forEach(tenant => organisationTenants.push(tenant.name));
  }

  updateAvailableTenantContactRoles(organisationTenants);
});

const isOpenpgpKeyValid = ref(true);
const isSmimeKeyValid = ref(true);
const openpgpErrorMessage = ref();
const fileContent = ref({});
const smimeErrorMessage = ref();
const checkUploadedFile = item => {
  if (contactValues.value[item.name]) {
    const reader = new FileReader();
    reader.readAsText(contactValues.value[item.name], 'utf-8');
    reader.onload = event => {
      const content = event.target ? event.target.result : "";
      // First check for private key existence
      if (content as string) {
        const matched = (content as string).match(
          /(PRIVATE|PKCS12|protected-private-key)/g
        );
        if (matched) {
          const errorMessage = `This file looks like it contains private key material. (It matched the string ${matched[0]}). Only ascii-armored public keys/certificates are allowed.`;
          if (item.type === "openpgp_pubkey") {
            isOpenpgpKeyValid.value = false;
            openpgpErrorMessage.value = errorMessage;
          } else {
            isSmimeKeyValid.value = false;
            smimeErrorMessage.value = errorMessage;
          }
        } else {
          // Second check for correct ascii-armored public key material
          const notValidMessage = "The file looks like it is not an ascii-armored public key material";
          const lines = (content as string).split(/\r?\n|\r/g);
          const fileEndOffset = lines[lines.length -1] === "" ? 2 : 1;

          if (lines && item.type === "openpgp_pubkey") {
            if (! isPublicKeyValid(lines, fileEndOffset)) {
              isOpenpgpKeyValid.value = false;
              openpgpErrorMessage.value = notValidMessage;
            }
          } else if (lines && item.type === "s_mime_cert") {
            if (! isCertificateValid(lines, fileEndOffset)) {
              isSmimeKeyValid.value = false;
              smimeErrorMessage.value = notValidMessage;
            }
          }
        }
        // Save the content as it is valid to be sent as string
        // in the HTTP request
        if (
          (isOpenpgpKeyValid.value && item.type === "openpgp_pubkey") ||
          (isSmimeKeyValid.value && item.type === "s_mime_cert")
        ) {
          fileContent.value[item.name] = content;
        }
      }
    };
  }
};

const checkDynamicEmailField = e => {
  if (e.changed) {
    editFormChanged();
  }

  contactValues.value[e.fieldName] = e.fieldValue;
}

const isCertificateValid = (fileLines, fileEndOffset) => {
  return (/-----BEGIN CERTIFICATE-----/.test(fileLines[0]) &&
          /-----END CERTIFICATE-----/.test(fileLines[fileLines.length - fileEndOffset])) ||
      (/-----BEGIN PKCS7-----/.test(fileLines[0]) &&
          /-----END PKCS7-----/.test(fileLines[fileLines.length - fileEndOffset]));
}

const isPublicKeyValid = (fileLines, fileEndOffset) => {
  return /-----BEGIN PGP PUBLIC KEY BLOCK-----/.test(fileLines[0]) &&
      /-----END PGP PUBLIC KEY BLOCK-----/.test(fileLines[fileLines.length - fileEndOffset]);
}

const copyToClipboard = (text) => {
  navigator.clipboard.writeText(text);
}

const removeItemFromSelectedRole = (itemName) => {
  selectedRoles.value = selectedRoles.value.filter((item) => itemName !== item.name);
  initializeFields();
}

const triggerFormValidation = () => {
  form.value.validate();
}

const clearOrganisation = () => {
  isOrgaUpdating.value = true;
}

</script>
